

import numpy as np
import matplotlib.pyplot as plt
import h5py
import scipy.io as sio
from keras.models import Sequential
from keras.layers import Dense
import tensorflow as tf




filepath = 'OutputData.mat'
temp = {}
f = h5py.File(filepath,'r')
for k, v in f.items():
    temp[k] = np.array(v)
    
Y_train = np.transpose(temp['OutputData']);

filepath = 'InputData.mat'
temp = {}
f = h5py.File(filepath,'r')
for k, v in f.items():
    temp[k] = np.array(v)
    
X_train = np.transpose(temp['InputData']);

temp = sio.loadmat('A.mat');
A = temp['A'];

#BeamOp = sio.loadmat('BeamOp.mat');
#Y_train = BeamOp['BeamOp'];
#
#SigRx = sio.loadmat('SigRx.mat');
#X_train = SigRx['SigRx'];

nLabel = np.size(Y_train,0);
InpSize = np.size(X_train,1);
OutSize = np.size(Y_train,1);

NeuronInHiddenLayer = InpSize*10;



def CustomLoss(yTrue,yPred):
    sizeV = tf.shape(yTrue)
    tf_A = tf.constant(A)
    tf_A =tf.cast(tf_A, tf.float32);
    tf_A = tf.reshape(tf_A,[1,InpSize,OutSize]) 
    tf_A_A = tf.tile(tf_A,[sizeV[0],1,1]) 
    x = tf.reshape(yPred,[sizeV[0],OutSize,1]) 
    Ax = tf.matmul(tf_A_A,x,transpose_a=False, transpose_b=False)
    y = tf.reshape(yTrue,[sizeV[0],InpSize,1])    
    L1 = tf.reduce_mean(tf.square(tf.abs(y-Ax)),axis=1)
    t2 = tf.cast(x,tf.int64)
    L2 = tf.count_nonzero(t2,axis = 1)
 #   L2 = tf.reduce_sum(tf.abs(x),axis = 1)    
 #   L2 = tf.cast(L2,tf.float32)
    
    L1 = tf.reshape(L1,[sizeV[0],1]) 
    L2 = tf.reshape(L2,[sizeV[0],1]) 
    Z = 0*L1+L2
    
    return(Z)    

model = Sequential();


model.add(Dense(output_dim =NeuronInHiddenLayer,activation = 'linear',input_dim=InpSize));
model.add(Dense(output_dim =NeuronInHiddenLayer,activation = 'relu',input_dim=NeuronInHiddenLayer ));
model.add(Dense(output_dim =NeuronInHiddenLayer,activation = 'relu',input_dim=NeuronInHiddenLayer));
model.add(Dense(output_dim =NeuronInHiddenLayer,activation = 'relu',input_dim=NeuronInHiddenLayer));
model.add(Dense(output_dim =NeuronInHiddenLayer,activation = 'relu',input_dim=NeuronInHiddenLayer));#
model.add(Dense(output_dim =NeuronInHiddenLayer,activation = 'relu',input_dim=NeuronInHiddenLayer));
model.add(Dense(output_dim =OutSize,activation = 'linear',input_dim=NeuronInHiddenLayer));
model.summary()




model.compile(optimizer='adam',loss=CustomLoss,metrics =['accuracy']);

history = model.fit(X_train,X_train,batch_size=1000,nb_epoch = 20,shuffle =True,validation_split=.1);

model.save('SparseRecoveryModel.h5') 




print(history.history.keys())
plt.plot(history.history['acc'])
plt.plot(history.history['val_acc'])
plt.title('model accuracy')
plt.ylabel('accuracy');
plt.xlabel('epoch');
plt.legend(['train' 'test'],loc='upper left')
plt.show();


plt.plot(history.history['loss'])
plt.plot(history.history['val_loss'])
plt.title('model loss')
plt.ylabel('loss');
plt.xlabel('epoch');
plt.legend(['train' 'test'],loc='upper left')
plt.show();