

#import numpy as np
#import matplotlib.pyplot as plt
#import pandas as pd
import scipy.io as sio
import time
import tensorflow as tf 




from keras.models import load_model
from keras.utils import plot_model
temp = sio.loadmat('A.mat');
A = temp['A'];
OutSize = 50;
InpSize = 30;

def CustomLoss(yTrue,yPred):
    sizeV = tf.shape(yTrue)
    tf_A = tf.constant(A)
    tf_A =tf.cast(tf_A, tf.float32);
    tf_A = tf.reshape(tf_A,[1,InpSize,OutSize]) 
    tf_A_A = tf.tile(tf_A,[sizeV[0],1,1]) 
    x = tf.reshape(yPred,[sizeV[0],OutSize,1]) 
    Ax = tf.matmul(tf_A_A,x,transpose_a=False, transpose_b=False)
    y = tf.reshape(yTrue,[sizeV[0],InpSize,1])    
    L1 = tf.reduce_mean(tf.square(tf.abs(y-Ax)),axis=1)
    #t2 = tf.cast(x,tf.int64)
    #L2 = tf.count_nonzero(t2,axis = 1)
    L2 = tf.reduce_sum(tf.abs(x),axis = 1)    
    L2 = tf.cast(L2,tf.float32)
    
    L1 = tf.reshape(L1,[sizeV[0],1]) 
    L2 = tf.reshape(L2,[sizeV[0],1]) 
    Z = 0*L1+.4*L2
    
    return(Z)    
    

model = load_model('SparseRecoveryModel.h5',custom_objects={'tf': tf,'CustomLoss':CustomLoss}) # OMP learning model
plot_model(model, to_file='model.png')





str2 = 'TestInputData' ; #+str(currSNR)
SigTest = sio.loadmat(str2);
X_test = SigTest['TestInputData'];

#predicting the DNN output
start_time = time.time()
Y_pred = model.predict((X_test));
endtime = time.time() 
elapsed_time = endtime - start_time


#saving the predicted data

str3 = 'TestOutputPred' ;#+str(currSNR)
sio.savemat(str3, {'TestOutputPred':Y_pred});
print(elapsed_time);
   # print(start_time);
   # print(endtime);