

import numpy as np
import matplotlib.pyplot as plt
import h5py

from keras.models import Model
from keras.layers import Input,Dense,Concatenate





filepath = 'OutputData.mat'
temp = {}
f = h5py.File(filepath,'r')
for k, v in f.items():
    temp[k] = np.array(v)
    
Y_train = np.transpose(temp['OutputData']);

filepath = 'InputData.mat'
temp = {}
f = h5py.File(filepath,'r')
for k, v in f.items():
    temp[k] = np.array(v)
    
X_train = np.transpose(temp['InputData']);

#BeamOp = sio.loadmat('BeamOp.mat');
#Y_train = BeamOp['BeamOp'];
#
#SigRx = sio.loadmat('SigRx.mat');
#X_train = SigRx['SigRx'];

nLabel = np.size(Y_train,0);
InpSize = np.size(X_train,1);
OutSize = np.size(Y_train,1);

NeuronInHiddenLayer = InpSize*10;








inputs = Input(shape=(InpSize,))
L1 = Dense(NeuronInHiddenLayer,activation='linear')(inputs) 
L2 = Dense(NeuronInHiddenLayer,activation='relu')(L1) 
L3 = Dense(NeuronInHiddenLayer,activation='relu')(L2) 
L4 = Dense(NeuronInHiddenLayer,activation='relu')(L3)
L5 =  Concatenate()([L3,L4]) 
L6 = Dense(NeuronInHiddenLayer,activation='relu')(L5) 
L7 = Dense(OutSize,activation='linear')(L6) 


My_Model = Model(inputs,L7)
        



My_Model.summary()




My_Model.compile(optimizer='adam',loss='mse',metrics =['accuracy']);

history = My_Model.fit(X_train,Y_train,batch_size=1000,nb_epoch = 20,shuffle =True,validation_split=.1);

My_Model.save('SparseRecoveryModel.h5') 




print(history.history.keys())
plt.plot(history.history['acc'])
plt.plot(history.history['val_acc'])
plt.title('model accuracy')
plt.ylabel('accuracy');
plt.xlabel('epoch');
plt.legend(['train' 'test'],loc='upper left')
plt.show();


plt.plot(history.history['loss'])
plt.plot(history.history['val_loss'])
plt.title('model loss')
plt.ylabel('loss');
plt.xlabel('epoch');
plt.legend(['train' 'test'],loc='upper left')
plt.show();