import numpy as np
import scipy.io as sio
import h5py
from keras.models import Model
from keras.layers import Dense,Input,Lambda
from keras import layers
import tensorflow as tf
from keras.layers.core import Activation


filepath = 'OutputData.mat'
BeamOp = {}
f = h5py.File(filepath,'r')
for k, v in f.items():
    BeamOp[k] = np.array(v)
    
Y_train = np.transpose(BeamOp['OutputData']);



filepath = 'InputData.mat'
SigRx = {}
f = h5py.File(filepath,'r')
for k, v in f.items():
    SigRx[k] = np.array(v)
    
X_train = np.transpose(SigRx['InputData']);




nLabel = np.size(Y_train,0);
InpSize = np.size(X_train,1);
OutSize = np.size(Y_train,1);


NeuronInHiddenLayer = OutSize;






#    
BeamOp = sio.loadmat('A.mat');
A = BeamOp['A'];

 



def muEstimate(args):
    y,alpha,sigma = args
    alpha = tf.abs(alpha)
    sizeV = tf.shape(alpha)
    sigma = tf.abs(sigma)     
 #   alphaHalf = tf.sqrt(alpha)

    temp = tf.constant(1) 
    temp =tf.cast(temp, tf.float32);
  
    InvalphaHalf =  tf.truediv(temp,alpha+.001); 

    DSc = tf.zeros([sizeV[0],OutSize,OutSize])    
    

    Sc = tf.linalg.set_diag(DSc, sigma)    
    
    D_ = tf.zeros([sizeV[0],OutSize,OutSize])    
   
    D1 = tf.linalg.set_diag(D_, InvalphaHalf)  
    tf_A = tf.constant(A)
    tf_A =tf.cast(tf_A, tf.float32);
    tf_A = tf.reshape(tf_A,[1,InpSize,OutSize]) 
    tf_A_A = tf.tile(tf_A,[sizeV[0],1,1]) 
    #A_D = tf.matmul(tf_A_A,D,transpose_a=False, transpose_b=False) 
    A_D_A_D = tf.matmul(tf_A_A,tf_A_A,transpose_a=True, transpose_b=False)
    
    A_D_inv_ = tf.matrix_inverse(Sc*D1+A_D_A_D)

    A_D_inv = tf.matmul(A_D_inv_,tf_A_A,transpose_a=False, transpose_b=True) 
    
    phi = tf.matmul(A_D_inv_,Sc,transpose_a=False, transpose_b=False) 
    
    phi_D = tf.linalg.diag_part(phi)   
    phi_D = tf.reshape(phi_D,[sizeV[0],OutSize])  
        
    y = tf.reshape(y,[sizeV[0],InpSize,1]) 
    mu = tf.matmul(A_D_inv,y,transpose_a=False, transpose_b=False)    

    mu = tf.reshape(mu,[sizeV[0],OutSize])    
    return([mu,phi_D])   
    
    
    
class SparseNet:
	#@staticmethod
	def SBL(y,alpha_0,sigma0):
    

		[mu_1,phi_1]=  Lambda(function = muEstimate)([y,alpha_0,sigma0])         
		T1_1 = layers.Multiply()([mu_1, mu_1]) 
		C_1 = layers.Concatenate(axis=-1)([phi_1,T1_1])
		alpha_1= Dense(OutSize,activation='linear')(C_1)       
	        
		[mu_2,phi_2]=  Lambda(function = muEstimate)([y,alpha_1,sigma0])      
		T1_2 = layers.Multiply()([mu_2, mu_2]) 
		C_2 = layers.Concatenate(axis=-1)([phi_2,T1_2])
		alpha_2= Dense(OutSize,activation='linear')(C_2)   
		[mu_3,phi_3]=  Lambda(function = muEstimate)([y,alpha_2,sigma0]) 	


         
		T1_3 = layers.Multiply()([mu_3, mu_3]) 
		C_3 = layers.Concatenate(axis=-1)([phi_3,T1_3])
		alpha_3= Dense(OutSize,activation='linear')(C_3)   
		[mu_4,phi_4]=  Lambda(function = muEstimate)([y,alpha_3,sigma0]) 	


         
		T1_4 = layers.Multiply()([mu_4, mu_4]) 
		C_4 = layers.Concatenate(axis=-1)([phi_4,T1_4])
		alpha_4= Dense(OutSize,activation='linear')(C_4)   
		[mu_5,phi_5]=  Lambda(function = muEstimate)([y,alpha_4,sigma0]) 	



       
		T1_5 = layers.Multiply()([mu_5, mu_5]) 
		C_5 = layers.Concatenate(axis=-1)([phi_5,T1_5])
		alpha_5= Dense(OutSize,activation='linear')(C_5)   
		[mu_6,phi_6]=  Lambda(function = muEstimate)([y,alpha_5,sigma0]) 	
        
        
        
        
		T1_6 = layers.Multiply()([mu_6, mu_6]) 
		C_6 = layers.Concatenate(axis=-1)([phi_6,T1_6])
		alpha_6= Dense(OutSize,activation='linear')(C_6)   
		[mu_7,phi_7]=  Lambda(function = muEstimate)([y,alpha_6,sigma0]) 	        
        
        


    
		T1_7 = layers.Multiply()([mu_7, mu_7]) 
		C_7 = layers.Concatenate(axis=-1)([phi_7,T1_7])
		alpha_7= Dense(OutSize,activation='linear')(C_7)   
		[mu_8,phi_8]=  Lambda(function = muEstimate)([y,alpha_7,sigma0]) 	
        
     
		return [mu_2,mu_3,mu_4,mu_5,mu_6,mu_7,mu_8]  
	

    
	@staticmethod
	def OutLayer1(inputs):        
    
		x= Activation("linear", name="OutLayer1")(inputs) 
		#SparseNet.Mapping_branch.trainable = False 	         
		return x
	def OutLayer2(inputs):        
    
		x= Activation("linear", name="OutLayer2")(inputs) 
		#SparseNet.Mapping_branch.trainable = False 	         
		return x	

	def OutLayer3(inputs):        
    
		x= Activation("linear", name="OutLayer3")(inputs) 
		#SparseNet.Mapping_branch.trainable = False 	         
		return x
	def OutLayer4(inputs):        
    
		x= Activation("linear", name="OutLayer4")(inputs) 
		#SparseNet.Mapping_branch.trainable = False 	         
		return x	

	def OutLayer5(inputs):        
    
		x= Activation("linear", name="OutLayer5")(inputs) 
		#SparseNet.Mapping_branch.trainable = False 	         
		return x
	def OutLayer6(inputs):        
    
		x= Activation("linear", name="OutLayer6")(inputs) 
		#SparseNet.Mapping_branch.trainable = False 	         
		return x	
    
	def OutLayer7(inputs):        
    
		x= Activation("linear", name="OutLayer7")(inputs) 
		#SparseNet.Mapping_branch.trainable = False 	         
		return x	
    
	def OutLayer8(inputs):        
    
		x= Activation("linear", name="OutLayer8")(inputs) 
		#SparseNet.Mapping_branch.trainable = False 	         
		return x	
    

inputs1 = Input(shape=(InpSize,))
inputs2 = Input(shape=(OutSize,))
inputs3 = Input(shape=(OutSize,))
inputs4 = Input(shape=(OutSize,))

SparseBranch1 = SparseNet.SBL(inputs1,inputs2,inputs3)


SBL= Model(inputs=[inputs1,inputs2,inputs3], outputs=SparseBranch1) 

[mu_1,mu_2,mu_3,mu_4,mu_5,mu_6,mu_7] =SBL([inputs1,inputs2,inputs3])



mu_1 = SparseNet.OutLayer1(mu_1)
mu_2 = SparseNet.OutLayer2(mu_2)
mu_3 = SparseNet.OutLayer3(mu_3)
mu_4 = SparseNet.OutLayer4(mu_4)
mu_5 = SparseNet.OutLayer5(mu_5)
mu_6 = SparseNet.OutLayer6(mu_6)
mu_7 = SparseNet.OutLayer7(mu_7)



g = Model(inputs=[inputs1,inputs2,inputs3], output=[mu_1,mu_2,mu_3,mu_4,mu_5,mu_6,mu_7])
#
losses = {
	"OutLayer1": "mse",
	"OutLayer2": "mse",	
    	"OutLayer3": "mse",	 
    	"OutLayer4": "mse",	   
	"OutLayer5": "mse",	
    	"OutLayer6": "mse",	 
    	"OutLayer7": "mse",	         
}
lossWeights = {"OutLayer1":1,"OutLayer2": 1,"OutLayer3": 1,"OutLayer4": 1,"OutLayer5": 1,"OutLayer6": 1,"OutLayer7": 1}

g.compile(optimizer="adam", loss=losses, loss_weights=lossWeights,
	metrics=["accuracy"])




varEst = np.ones([np.size(Y_train,0),np.size(Y_train,1)])*1e-1   
alpha_0 = np.ones([np.size(Y_train,0),np.size(Y_train,1)]) 
for epoch in range(1):
    Shading = np.ones([np.size(Y_train,0),np.size(Y_train,1)])

    g.fit([X_train,alpha_0,varEst], [Y_train,Y_train,Y_train,Y_train,Y_train,Y_train,Y_train],batch_size=1000,nb_epoch = 20,shuffle =True,validation_split=.1);
    SBL.save('SBL.h5') 





